unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, TAGraph, TAMultiSeries,
  TARadialSeries, TASeries;

type

  { TForm1 }

  TForm1 = class(TForm)
    Chart1: TChart;
    Chart1FieldSeries1: TFieldSeries;
    Chart1LineSeries1: TLineSeries;
    Chart1PolarSeries1: TPolarSeries;
    procedure FormCreate(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  Math, TAChartUtils;

{ TForm1 }

procedure xy2Polar(x, y: Double; out r, phi: Double);
begin
  phi := arctan2(y, x);
  r := sqrt(x*x + y*y);
end;

procedure TForm1.FormCreate(Sender: TObject);
const
  // Eckpunkte des Polygons und Startpunkte der Pfeile
  P: array[0..2] of TDoublePoint = (
    (X:5.0; Y:-3.0),
    (X:-2.0; Y:4.5),
    (X:-3.3; Y:-4.1)
  );
  // Richtungsvektoren für die Pfeile
  V: array[0..2] of TDoublePoint = (
    (X:2.5; Y:-1.2),
    (X:-0.4; Y:2.0),
    (X:-1.9; Y:-2.3)
  );
var
  r, phi: Double;

begin
  Chart1.Proportional := true;

  (*
  // Die einfachse Art die Umrisse des Tuchs zu zeigen ist mit einer LineSeries.
  // Nur kann man damit das Polygon nicht füllen
  Chart1LineSeries1.LinePen.Color := clBlue;
  Chart1LineSeries1.AddXY(P[0].X, P[0].Y);
  Chart1LineSeries1.AddXY(P[1].X, P[1].Y);
  Chart1LineSeries1.AddXY(P[2].x, P[2].Y);
  Chart1LineSeries1.AddXY(P[0].X, P[0].Y);  // das Polygon muss manuell geschlossen werden.
  *)

  // Mit einer TPolarSeries kann man das Polygon füllen. Allerdings erwartet
  // diese die Eingabe-Daten in Polarkoordinaten. D.h. wir müssen die hier
  // implementierte Routine xy2Polar aufrufen, die die Umrechnung vornimmt.
  Chart1PolarSeries1.CloseCircle := true;
  Chart1PolarSeries1.Filled := true;
  Chart1PolarSeries1.Brush.Color := clYellow;
  xy2Polar(P[0].X, P[0].Y, r, phi);
  Chart1PolarSeries1.AddXY(phi, r);
  xy2Polar(P[1].X, P[1].Y, r, phi);
  Chart1PolarSeries1.AddXY(phi, r);
  xy2Polar(P[2].X, P[2].Y, r, phi);
  Chart1PolarSeries1.AddXY(phi, r);

  // Die FieldSeries zeichnet die Pfeile. Dafür sind zwei x/y-Wertepaare pro
  // Pfeil nötig. In v2.0.10 ist angenommen, dass das erste x/y Paar den Mittelpunkt
  // des Pfeils angibt und das zweite die Richtung. Um die Pfeile am angegebenen
  // Startpunkt beginnen lassen zu können, müssen wir den 1. Vektor um den halben
  // Richtungsvektor verschieben.
  Chart1FieldSeries1.Arrow.Width := 6;
  Chart1FieldSeries1.Arrow.Length := 15;
  Chart1FieldSeries1.Arrow.BaseLength := Chart1FieldSeries1.Arrow.Length;
  Chart1FieldSeries1.Pen.Color := clRed;
  Chart1fieldSeries1.Pen.Width := 3;
  Chart1FieldSeries1.AddVector(P[0].X + V[0].X/2, P[0].Y + V[0].Y/2, V[0].X, V[0].Y);
  Chart1FieldSeries1.AddVector(P[1].X + V[1].X/2, P[1].Y + V[1].Y/2, V[1].X, V[1].Y);
  Chart1FieldSeries1.AddVector(P[2].X + V[2].X/2, P[2].Y + V[2].Y/2, V[2].X, V[2].Y);
end;
end.

